using System;
using System.Web;
using System.Collections;
using System.Threading;

namespace MDS.Comet
{

	/// <summary>
	/// wqȤ
	/// </summary>
	public class CometClient
	{
		public string PrivateToken;
		public string PublicToken;
		public string LoginIp;
		public string LoginTime;
		public string Description;
		public int TimedOutCount;
		public int MessageCount = 1000;
		public bool NeverConnected = true;

		//  a list of messages
		//public List<CometMessage> Messages = new List<CometMessage>();
		public ArrayList Messages=new ArrayList ();

		//  an autoreset event that is handy to identify when this client is connected or not
		public AutoResetEvent EventWaitHandle = new AutoResetEvent(false);

		//  this is the current operation that we are executing on the server
		//  we can only have 1 per client, if a current request is open, we end cancel it
		//public Queue<AsyncResult> Requests = new Queue<AsyncResult>();
		public AsyncResult CurrentRequest = null;
	}
    /// <summary>
    /// Awq
    /// </summary>
	public enum CompletionState
	{
		Timedout,
		Cancelled,
		Messages
	}
	/// <summary>
	/// ܲBШD
	/// </summary>
	public class AsyncResult : IAsyncResult
	{
		private HttpContext context = null;
		private bool isCompleted = false;
		private object asyncState;
		private AsyncCallback callback;
		private CompletionState completionState;
		private int lastMessageId = 0;
		private CometClient client;

		public AsyncResult(CometClient client, HttpContext context, AsyncCallback callback, object asyncState)
		{
			this.context = context;
			this.asyncState = asyncState;
			this.callback = callback;
			this.client = client;
			//  get the last message id
			this.lastMessageId = int.Parse(context.Request["lastMessageId"]);
		}

		public HttpContext Context
		{
			get { return this.context; }
		}
		#region IAsyncResult Members

		public object AsyncState
		{
			get { return this.context; }
		}

		public System.Threading.WaitHandle AsyncWaitHandle
		{
			get { throw new NotSupportedException(); }
		}

		public bool CompletedSynchronously
		{
			get { return false; }
		}

		public int LastMessageId
		{
			get { return this.lastMessageId; }
		}

		public bool IsCompleted
		{
			get { return this.isCompleted; }            
		}

		public CompletionState CompletionState
		{
			get { return this.completionState; }
		}

		public CometClient Client
		{
			get { return this.client; }
		}

		public void SetCompleted(CompletionState completionState)
		{
			this.isCompleted = true;
			this.completionState = completionState;
			if (callback != null)
				callback(this);
		}

		#endregion
	}

}
