using System;

using System.Web;
using System.Threading;
using System.Diagnostics;
using MDS.Comet ;

namespace MDS.Comet
{
	
	public class ChatChannelHandler : ChannelHandler
	{
		private static CometClientManager clientManager = new CometClientManager();
 
		public AutoResetEvent EventWaitHandle = new AutoResetEvent(false);
		static ChatChannelHandler()
		{
			
			//clientManager.InitializeClient("testPublic", "testPrivate");
			clientManager.ClientDisconnected += new CometClientEventHandler(clientManager_ClientDisconnected);
			clientManager.ClientConnected += new CometClientEventHandler(clientManager_ClientConnected);
		}

		static void  clientManager_ClientConnected(CometClient client)
		{
		 
			clientManager.SendMessagesToAllClients(new ChatMessage("ONLINE:", clientManager.publicClients.Count.ToString()  ));
		}

		static void clientManager_ClientDisconnected(CometClient client)
		{
			clientManager.SendMessagesToAllClients(new ChatMessage("OFFLINE:",   clientManager.publicClients.Count .ToString()+"|"+client.PublicToken  ));
		}

		public static CometClientManager ClientManager
		{
			get { return clientManager; }
		}

		protected override CometClientManager GetCometClientManagerForRequest(HttpContext context)
		{
			return clientManager;
		}
 
	}
}
