using System;
using System.Collections;
using System.Threading;
using System.Web;
using System.Data.OleDb;
namespace MDS.Comet
{
	public  delegate void CometClientEventHandler(CometClient client);
	public class CometClientManager
	{
		private object state = new object();
		public static string HasDB=System.Configuration.ConfigurationSettings.AppSettings["HasDB"].ToString();
		public static readonly int ConnectInterval=Convert.ToInt32(System.Configuration.ConfigurationSettings.AppSettings["ConnectInterval"].ToString());
		private static int IntervalTime=(System.Configuration.ConfigurationSettings.AppSettings["IntervalTime"].Length>0)?Convert.ToInt32(System.Configuration.ConfigurationSettings.AppSettings["IntervalTime"]):10000;
		//public Dictionary<string, CometClient> publicClients = new Dictionary<string, CometClient>();
		//private Dictionary<string, CometClient> privateClients = new Dictionary<string, CometClient>();
		public Hashtable publicClients =new Hashtable();
		public Hashtable privateClients =new Hashtable();
		

		public event CometClientEventHandler ClientConnected;
		public event CometClientEventHandler ClientDisconnected;

		public bool ClientExists(string publicToken)
		{
			return publicClients.ContainsKey(publicToken);
		}
		public void RemoveClient(string publicToken)
		{
			lock(state)
			{
				CometClient client=privateClients[publicToken] as CometClient ;
				publicClients.Remove(publicToken);
				privateClients.Remove(publicToken);
				if (this.ClientDisconnected != null)
					this.ClientDisconnected(client);
			}
		}
		public CometClient GetClientByPublicToken(string publicToken)
		{
			if (publicClients.ContainsKey(publicToken))
				return publicClients[publicToken] as CometClient;
			else
				return null;
		}
		public CometClient GetClientByPrivateToken(string privateToken)
		{
			if (privateClients.ContainsKey(privateToken))
				return privateClients[privateToken] as CometClient ;
			else
				return null;
		}
		public void InitializeClient(string publicToken, string privateToken,string LoginIp,string Description)
		{
			if (publicToken==string.Empty || publicToken==null)
				throw new ArgumentNullException("publicToken");

			if (privateToken==string.Empty||privateToken==null)
				throw new ArgumentNullException("privateToken");

			//
			//  lock the state and add the client into the
			//  list of clients
			lock (state)
			{
				if (publicClients.ContainsKey(publicToken))
					throw new Exception("Public token already exists.");

				if (privateClients.ContainsKey(privateToken))
					throw new Exception("Private token already exists.");

				CometClient client = new CometClient();

				client.PublicToken = publicToken;
				client.PrivateToken = privateToken;
				client.Description=Description;
				client.LoginIp=LoginIp;
				client.LoginTime=DateTime.Now.ToString("yyyy-MM-dd HHmm");
				//
				//  use the two dictionaries to quickly lookup
				//  each client
				publicClients.Add(publicToken, client);
				privateClients.Add(privateToken, client);

				//
				//  start the client off waiting
				ThreadPool.UnsafeRegisterWaitForSingleObject(client.EventWaitHandle, new System.Threading.WaitOrTimerCallback(WaitOrTimerCallback)  , client, ConnectInterval, true);
				//ThreadPool.UnsafeRegisterWaitForSingleObject(client.EventWaitHandle, this.WaitOrTimerCallback, client, 5000, true);
				if(HasDB=="Y")
				{
					if (!IsStart)
					{
						ThreadPool.UnsafeRegisterWaitForSingleObject(eventX, new WaitOrTimerCallback(QueryTable), publicClients, IntervalTime, true);
						IsStart = true;
					}
				}
			}
		}
		public AutoResetEvent eventX = new AutoResetEvent(false);
		public bool IsStart = false;
		private void QueryTable(Object clientList, bool isCheck)
		{
			string UserName=string.Empty;
			Hashtable pubClients=clientList as  Hashtable;
			lock (pubClients)
			{
				bool continueWaitEvent = true;
				if (isCheck == true)
				{
					if (pubClients.Count == 0)
					{
						continueWaitEvent = false;
						IsStart=false;
					}
					else
					{
						try
						{
							foreach (string client in pubClients.Keys )
							{
								UserName=UserName+" '"+client+"' , ";
							}

							int i=UserName.LastIndexOf(",");
							UserName=UserName.Substring(0,i);
							string SQL_SELECT =" select B.SIGN_PEO,COUNT(1) COU From mds_sign_list a,mds_sign_history b where b.sign_id=a.sign_id and a.FLAG='S' AND B.FLAG='N' and B.IS_READ='N' AND B.SIGN_PEO   IN ("+UserName+") GROUP BY B.SIGN_PEO ";
							ArrayList messageList=new ArrayList();
							Hashtable messClient =new Hashtable ();
							using (OleDbDataReader rdr = OracleHelper.ExecuteReader(OracleHelper.ConnString, System.Data.CommandType.Text, SQL_SELECT, null))
							{
								while (rdr.Read())
								{
									messClient.Add(rdr["SIGN_PEO"].ToString(),rdr["COU"].ToString());
								}
							}
							foreach (string client in messClient.Keys )
							{
								ChatMessage cm=new ChatMessage("System",messClient[client].ToString());
								SendMessageToPublicClient(client, cm);
							}
						}
						catch
						{
							continueWaitEvent = false;
							IsStart=false;
						}
					}
				}
				if (continueWaitEvent == true)
				{
					ThreadPool.UnsafeRegisterWaitForSingleObject(eventX, new WaitOrTimerCallback(QueryTable), pubClients, IntervalTime, true);
				}
			}
		}
		private void WaitOrTimerCallback(object c, bool timedout)
		{
			//
			//  an AutoResetEvent has been signalled eiter by a timeout
			//  or messages ready in the queue
			CometClient client = c as CometClient;
			lock(client)
			{
				bool continueWaitEvent = true;
				//
				//  if we are timing out, or we do not have an active request
				//  then we need to do some cleaning up..
				//pGO5
				if (timedout == true || client.CurrentRequest == null)
				{
					//  we have no activate request, which means the client
					//  whcih should mean the client is not connected 
					//  to the server, so this means we need to keep track
					//  of how many times this has happened ( in sequence )
					//  before we time the client out
					if (client.CurrentRequest == null)
					{
						//  increment the counter
						client.TimedOutCount++;
						//  if we have reached this timeout event 3 consecutive times 
						//  then assume the client has disconnected without
						//  gracefully informing the server!
						if (client.TimedOutCount >= 2)
						{
							//
							//  remove the client from the cache on the server
							//  clean them up and fire any disconnection events
							this.KillIdleClient(client);
							//  DONT continue this autoresetevent to keep waiting.. it
							//  is no longer needed
							continueWaitEvent = false;
						}
					}
					else
					{
						//
						//  we are connected, so we reset the timedoutcount 
						client.TimedOutCount = 0;
						//  complete the request sending back the "TIMEDOUT"
						//  message type.. this will trigger the COMET client
						//  to reconnect straight away ready for more messages
						AsyncResult result = client.CurrentRequest;
						//  clear the request (not currently connected)
						client.CurrentRequest = null;
						//  and complete it
						result.SetCompleted(CompletionState.Timedout);

					}
				}
				else
				{
					//
					//  ok, we have not timed out, we have been signalled, which means we
					//  have some events that we want to return to the client
					client.TimedOutCount = 0;
					//  and end
					AsyncResult result = client.CurrentRequest;
					//  clear the request (not currently connected)
					client.CurrentRequest = null;
					//  and complete the request, sending back 
					//  any messages we have queued up
					result.SetCompleted(CompletionState.Messages);
				}

				//
				//  if we are told to continue this thread.. then 
				//  do so
				if (continueWaitEvent)
				{
					//
					//  start the client off waiting again
					//]mȤqs
					ThreadPool.UnsafeRegisterWaitForSingleObject(client.EventWaitHandle,  new System.Threading.WaitOrTimerCallback(WaitOrTimerCallback), client, ConnectInterval, true);
				}
			}
		}
		//public IEnumerable<CometMessage> GetMessagesForClient(CometClient cometClient, int lastMessageId)
		public ICollection  GetMessagesForClient(CometClient cometClient, int lastMessageId)
		{  
			lock (cometClient)
			{
				ArrayList toDelete=new ArrayList();
				ArrayList toReturn=new ArrayList();
				foreach (CometMessage message in cometClient.Messages)
				{
					if (message.MessageId > lastMessageId)
						toReturn.Add(message);
					else if (message.MessageId <= lastMessageId)
						toDelete.Add(message);
				}
				foreach (CometMessage message in toDelete)
					cometClient.Messages.Remove(message);
				return toReturn.ToArray();
			}
		}
		private void KillIdleClient(CometClient client)
		{
			//
			//  fire an event here to nofity the consumer
			//  we have lost a client
			lock(state)
			{
				publicClients.Remove(client.PublicToken);
				privateClients.Remove(client.PrivateToken);
			}

			if (this.ClientDisconnected != null)
				this.ClientDisconnected(client);
		}
		public AsyncResult QueueRequest(HttpContext context, AsyncCallback callback, object asyncState)
		{
			string privateToken = context.Request["privateToken"];

			if (privateToken==null || privateToken==string.Empty )
				throw new Exception("Missing privateToken");

			lock (state)
			{
				//
				//  ok, lets get the parameters
				
				if (!privateClients.ContainsKey(privateToken ))
					throw new Exception("CometClient does not exist");

				//
				//  get the client from setup clients
				//  this user should have already been initialized
				//  using the InitializeClient method
				CometClient client = privateClients[privateToken] as CometClient;
                
				lock (client)
				{
					//
					//  if we have never connected before we must
					//  fire the event to signal any subscribers that
					//  we have connected
					if (client.NeverConnected)
					{
						if (this.ClientConnected != null)
							this.ClientConnected(client);
						//  we have conected now
						client.NeverConnected = false;
					}

					//
					//  if current request is not null a client is already
					//  attach to the server using this private token, so to
					//  make things a bit simpler we the current request to
					//  only allow 1 to be active at any 1 time
					if (client.CurrentRequest != null)
					{
						//
						//  we have a current request
						AsyncResult request = client.CurrentRequest;
						//  clear it
						client.CurrentRequest = null;
						//  and end it
						request.SetCompleted(CompletionState.Cancelled);
					}

					//  
					//  and hookup the new one, create the asyncresult object that contains
					//  all the information needed to complete this request
					//  client.. http context callback method etc..
					client.CurrentRequest = new AsyncResult(client, context, callback, asyncState);

					//
					//  ok, do we have messages that we are interested in?
					//  If we have some messages currently queued up we set the autoresetevent
					//  to complete the request
					if (client.Messages.Count > 0)
					{
						//  we have some messages, so lets cancel this signla this request
						client.EventWaitHandle.Set();
					}

					//  and return the current request
					return client.CurrentRequest;
				}

			}
		}
		/// <summary>
		/// 2
		/// </summary>
		/// <param name="message"></param>
		public void SendMessagesToAllClients(object message)
		{
			//
			//  iterate through each client
			//  and add a message to their queue, along
			//  with setting the autoresetevent for each
			//  triggering any request to complete
			foreach (CometClient client in this.publicClients.Values)
			{
				lock (client)
				{
					//  else, add it in
					client.MessageCount++;
					client.Messages.Add(new CometMessage(client.MessageCount, "MESSAGE", message));
					//
					//  if we are connected, then trigger the 
					//  event to complete the request
					if (client.CurrentRequest != null)
						((AutoResetEvent)client.EventWaitHandle).Set();
				}
			}
		}
		/// <summary>
		/// 
		/// </summary>
		/// <param name="publicToken"></param>
		/// <param name="message"></param>
		public void SendMessageToPublicClient(string publicToken, object message)
		{
			if (publicToken.Length==0)
				throw new ArgumentNullException("publicToken");

			if (message == null)
				throw new ArgumentNullException("message");

			lock (state)
			{
				if (!publicClients.ContainsKey(publicToken))
					throw new Exception("Client does not exist");

				//  else, add it in
				CometClient client = publicClients[publicToken] as CometClient ;
				lock (client)
				{
					//
					//  add the message to the queue
					client.MessageCount++;
					client.Messages.Add(new CometMessage(client.MessageCount, "MESSAGE", message));
                 

					//
					//  if we are connected, then trigger the 
					//  event to complete the request
					if (client.CurrentRequest != null)
						((AutoResetEvent)client.EventWaitHandle).Set();
				}
			}
		}

	}
	/// <summary>
	/// {sШDAOHTTPAʡAqӹ{s
	/// </summary>
	public abstract class ChannelHandler : IHttpAsyncHandler
	{
		#region IHttpAsyncHandler Members

		protected abstract CometClientManager GetCometClientManagerForRequest(HttpContext context);

		protected virtual IAsyncResult OnQueueRequest(CometClientManager manager, HttpContext context, AsyncCallback cb, object extraData)
		{
			return manager.QueueRequest(context, cb, extraData);
		}

		public IAsyncResult BeginProcessRequest(HttpContext context, AsyncCallback cb, object extraData)
		{
 
			//  create the autoreset event
			//  this implementation of async results contains the event
			//  that will be signalled when a message is available
			//  or the client has timed out

			CometClientManager manager = this.GetCometClientManagerForRequest(context);
			if (manager != null)
			{
				return this.OnQueueRequest(manager, context, cb, extraData);
			}
			else
				throw new NotSupportedException("No CometClientManager exists to handle the request");
		}

		public void EndProcessRequest(IAsyncResult state)
		{
			AsyncResult result = state as AsyncResult;
			CometMessage message = new CometMessage();
			ArrayList messages=new ArrayList();
 

				CometClientManager manager = this.GetCometClientManagerForRequest(result.Context);
			if (manager == null)
				throw new NotSupportedException("No CometClientManager exists to handle the request");

			//
			//  depending on the completion state
			//  setup the response accordginly
			//  e.g timeout, cancelled, or messages
			switch (result.CompletionState)
			{
				case CompletionState.Cancelled:
					message = new CometMessage();
					message.Contents = "";
					message.MessageId = 0;
					message.Name = "CANCELLED";
					messages.Add(message);
					break;
				case CompletionState.Timedout:
					message = new CometMessage();
					message.Contents = "";
					message.MessageId = 0;
					message.Name = "TIMEDOUT";
					messages.Add(message);
					break;
				case CompletionState.Messages:
					messages.AddRange(manager.GetMessagesForClient(result.Client, result.LastMessageId));
					if(messages.Count == 0)
					{
						//
						//  this has happened because the
						//  client has responded immediatly after receiving the messages
						//  with an updated last message id, and none were available
						//  for the client
						message = new CometMessage();
						message.Contents = "";
						message.MessageId = 0;
						message.Name = "TIMEDOUT";
						messages.Add(message);
					}
					break;
			}

			this.OnSerializeMessages(result.Context, messages );
		}

		protected virtual void OnSerializeMessages(HttpContext context, ArrayList messages)
		{
 
			ArrayList knownTypes=new ArrayList();

			foreach (CometMessage checkMessage in messages)
			{
				if (checkMessage.Contents != null && !knownTypes.Contains(checkMessage.Contents.GetType()))
				{
					knownTypes.Add(checkMessage.Contents.GetType());
					ChatMessage FROM = checkMessage.Contents as ChatMessage;
					if (FROM != null)
					{
						context.Response.Write("MessageId:" + checkMessage.MessageId + ";Name:" + checkMessage.Name + ";Contents:" + checkMessage.Contents + ";From:" + FROM.From + ";Message:" + FROM.Message);
					}
					else
					{
						context.Response.Write("MessageId:" + checkMessage.MessageId + ";Name:" + checkMessage.Name + ";Contents:" + checkMessage.Contents);
					}

				}
			}
          
			//DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(CometMessage[]), knownTypes);
			//serializer.WriteObject(context.Response.OutputStream, messages.ToArray());
        

		}

		#endregion
		#region IHttpHandler Members

		public bool IsReusable
		{
			get { return true; }
		}

		public void ProcessRequest(HttpContext context)
		{
			throw new NotSupportedException();
		}

		#endregion
 
	}
	/// <summary>
	/// Ȥݮ
	/// </summary>
	public class CometMessage
	{
		private long messageId;
		private string name;
		private object contents;
		public CometMessage()
		{
		}
		public CometMessage(long messageId, string name, object contents)
		{
			this.messageId = messageId;
			this.name = name;
			this.contents = contents;
		}
		/// <summary>
		/// Gets or Sets the MessageId, used to track which message the Client last received
		/// </summary>
		public long MessageId
		{
			get { return this.messageId; }
			set { this.messageId = value; }
		}

		/// <summary>
		/// Gets or Sets the Content of the Message
		/// </summary>
		public object Contents
		{
			get { return this.contents; }
			set { this.contents = value; }
		}

		/// <summary>
		/// Gets or Sets the error message if this is a failure
		/// </summary>
		public string Name
		{
			get { return this.name; }
			set { this.name = value; }
		}
	}
	public class ChatMessage
	{

		private string from;

		private string message;
		public ChatMessage(string from, string message)
		{
			this.from = from;
			this.message = message;
		}
		public string From
		{
			get { return this.from; }
			set { this.from = value; }
		}

		public string Message
		{
			get { return this.message; }
			set { this.message = value; }
		}

	}
}