using System;
using System.Data;
using System.Data.OleDb;
using System.Collections;

namespace  MDS.Comet
{
	/// <summary>
	/// OracleHelper KnyzC
	/// </summary>
	public abstract class OracleHelper
	{
		private static Hashtable parmCache = Hashtable.Synchronized(new Hashtable());
		public static string ConnString=System.Configuration.ConfigurationSettings.AppSettings["p_link"].ToString();
		/// <summary>
		/// Ѽ
		/// </summary>
		/// <param name="cacheKey"></param>
		/// <returns></returns>
		public static OleDbParameter[] GetCachedParameters(string cacheKey)
		{
			OleDbParameter[] cachedParms = (OleDbParameter[])parmCache[cacheKey];
			if (cachedParms == null)
				return null;
			OleDbParameter[] clonedParms = new OleDbParameter[cachedParms.Length];
			for (int i = 0, j = cachedParms.Length; i < j; i++)
				clonedParms[i] = (OleDbParameter)((ICloneable)cachedParms[i]).Clone();
			return clonedParms;
		}
		/// <summary>
		/// wsѼƦCC
		/// </summary>
		/// <param name="cacheKey"></param>
		/// <param name="commandParameters"></param>
		public static void CacheParameters(string cacheKey, params OleDbParameter[] commandParameters)
		{
			parmCache[cacheKey] = commandParameters;
		}
		/// <summary>
		/// SQLyyC
		/// <para></para>
		/// <para>ҥ~p:</para>
		/// LĪSQLyyHεLĪѼơC
		/// </summary>
		/// <param name="cmdType">ާ@</param>
		/// <param name="cmdText">SQLyy</param>
		/// <param name="commandParameters">ѼƦC</param>
		public static void ExecuteNonQuery(CommandType cmdType, string cmdText, params OleDbParameter[] commandParameters)
		{

			using (OleDbConnection conn = new OleDbConnection(ConnString))
			{
				OleDbCommand cmd = new OleDbCommand();

				PrepareCommand(cmd, conn, null, cmdType, cmdText, commandParameters);
				int val = cmd.ExecuteNonQuery();
				cmd.Parameters.Clear();

			}
		}
		/// <summary>
		/// SQLyyA^ҼvTƦCơC
		/// </summary>
		/// <param name="connectionString">ƾڳsr</param>
		/// <param name="cmdType">ާ@</param>
		/// <param name="cmdText">SQLyy</param>
		/// <param name="commandParameters">ѼƦC</param>
		/// <returns></returns>
		public static int ExecuteNonQuery(string connectionString, CommandType cmdType, string cmdText, params OleDbParameter[] commandParameters)
		{
			OleDbCommand cmd = new OleDbCommand();
			using (OleDbConnection connection = new OleDbConnection(connectionString))
			{
				PrepareCommand(cmd, connection, null, cmdType, cmdText, commandParameters);
				int val = cmd.ExecuteNonQuery();
				cmd.Parameters.Clear();
				return val;
			}
		} /// <summary>
		/// SQLưȡA^ҼvTƦCơC
		/// </summary>
		/// <param name="connectionString">SQLư</param>
		/// <param name="cmdType">ާ@</param>
		/// <param name="cmdText">SQLyy</param>
		/// <param name="commandParameters">ѼƦC</param>
		/// <returns></returns>
		public static int ExecuteNonQuery(OleDbTransaction trans, CommandType cmdType, string cmdText, params OleDbParameter[] commandParameters)
		{
			OleDbCommand cmd = new OleDbCommand();
			PrepareCommand(cmd, trans.Connection, trans, cmdType, cmdText, commandParameters);
			int val = cmd.ExecuteNonQuery();
			cmd.Parameters.Clear();
			return val;
		}
		/// <summary>
		/// wݭnȪSQLyyѼƪlơC
		/// </summary>
		/// <param name="cmd"></param>
		/// <param name="conn"></param>
		/// <param name="trans"></param>
		/// <param name="cmdType"></param>
		/// <param name="cmdText"></param>
		/// <param name="commandParameters"></param>
		private static void PrepareCommand(OleDbCommand cmd, OleDbConnection conn, OleDbTransaction trans, CommandType cmdType, string cmdText, OleDbParameter[] commandParameters)
		{

			if (conn.State != ConnectionState.Open)
				conn.Open();
			cmd.Connection = conn;
			cmd.CommandText = cmdText;
			cmd.CommandType = cmdType;
			if (trans != null)
				cmd.Transaction = trans;
			if (commandParameters != null)
			{
				foreach (OleDbParameter parm in commandParameters)
					cmd.Parameters.Add(parm);
			}
		}
		/// <summary>
		/// SQLyyA^ƦCC
		/// <para></para>
		/// <para>ҥ~p:</para>
		/// LĪSQLyyHεLĪѼơC
		/// </summary>
		/// <param name="connectionString"></param>
		/// <param name="cmdType"></param>
		/// <param name="cmdText"></param>
		/// <param name="commandParameters"></param>
		/// <returns></returns>
		public static OleDbDataReader ExecuteReader(string connectionString, CommandType cmdType, string cmdText, params OleDbParameter[] commandParameters)
		{

			//Create the command and connection
			OleDbCommand cmd = new OleDbCommand();
			OleDbConnection conn = new OleDbConnection(connectionString);
			try
			{
				PrepareCommand(cmd, conn, null, cmdType, cmdText, commandParameters);
				OleDbDataReader rdr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
				cmd.Parameters.Clear();
				return rdr;
			}
			catch
			{
				conn.Close();
				throw;
			}
		}
		/// <summary>
		/// SQLyyA^wƦCȡC
		/// </summary>
		/// <param name="connectionString"></param>
		/// <param name="cmdType"></param>
		/// <param name="cmdText"></param>
		/// <param name="commandParameters"></param>
		/// <returns></returns>
		public static object ExecuteScalar(string connectionString, CommandType cmdType, string cmdText, params OleDbParameter[] commandParameters)
		{
			OleDbCommand cmd = new OleDbCommand();

			using (OleDbConnection conn = new OleDbConnection(connectionString))
			{
				PrepareCommand(cmd, conn, null, cmdType, cmdText, commandParameters);
				object val = cmd.ExecuteScalar();
				cmd.Parameters.Clear();
				return val;
			}
		}
		/// <summary>
		/// SQLưȡA^wƦCȡC
		/// </summary>
		/// <param name="connectionString"></param>
		/// <param name="cmdType"></param>
		/// <param name="cmdText"></param>
		/// <param name="commandParameters"></param>
		/// <returns></returns>
		public static object ExecuteScalar(OleDbTransaction transaction, CommandType commandType, string commandText, params OleDbParameter[] commandParameters)
		{
			if (transaction == null)
				throw new ArgumentNullException("transaction");
			if (transaction != null && transaction.Connection == null)
				throw new ArgumentException("The transaction was rollbacked	or commited, please	provide	an open	transaction.", "transaction");
			OleDbCommand cmd = new OleDbCommand();
			PrepareCommand(cmd, transaction.Connection, transaction, commandType, commandText, commandParameters);
			object retval = cmd.ExecuteScalar();
			cmd.Parameters.Clear();
			return retval;
		}
		/// <summary>
		/// SQLyyA^wƦCȡC
		/// </summary>
		/// <param name="connectionString"></param>
		/// <param name="cmdType"></param>
		/// <param name="cmdText"></param>
		/// <param name="commandParameters"></param>
		/// <returns></returns>
		public static object ExecuteScalar(OleDbConnection connectionString, CommandType cmdType, string cmdText, params OleDbParameter[] commandParameters)
		{
			OleDbCommand cmd = new OleDbCommand();

			PrepareCommand(cmd, connectionString, null, cmdType, cmdText, commandParameters);
			object val = cmd.ExecuteScalar();
			cmd.Parameters.Clear();
			return val;
		}
	}
}
